Index: tests/regression/Molecules/Copy/pre/tensid.data
===================================================================
--- tests/regression/Molecules/Copy/pre/tensid.data	(revision ccb487ddab59ad8050ce40929874510f2d9454f0)
+++ tests/regression/Molecules/Copy/pre/tensid.data	(revision 2034f3c5f9db8e8024a0f4db0cd3d1231e98ac24)
@@ -1,59 +1,59 @@
 # ATOMDATA	Id	name	resName	chainID	x=3	type	neighbors=4	charge
 # Box	20	0	0	0	20	0	0	0	20
-1	NA	SLES	1	32.397	35.231	26.737	NA	0	0	0	0	1.000000e+00	
-2	S	SLES	1	31.282	33.88	29.208	SL	3	4	5	6	1.330000e+00	
-3	OS1	SLES	1	30.788	33.072	28.08	OSL	2	7	0	0	-2.800000e-01	
-4	OS2	SLES	1	30.674	35.071	28.658	O2L	2	0	0	0	-6.500000e-01	
-5	OS3	SLES	1	32.652	33.652	28.81	O2L	2	0	0	0	-6.500000e-01	
-6	OS4	SLES	1	30.761	33.284	30.406	O2L	2	0	0	0	-6.500000e-01	
-7	C2	SLES	1	30.018	31.938	28.128	CC32A	3	8	9	10	-1.100000e-01	
-8	H2A	SLES	1	29.033	32.147	28.623	HCA2	7	0	0	0	9.000000e-02	
-9	H2B	SLES	1	30.55	31.115	28.675	HCA2	7	0	0	0	9.000000e-02	
-10	C1	SLES	1	29.84	31.605	26.631	CC32A	7	11	12	13	-1.000000e-02	
-11	H1B	SLES	1	29.337	32.448	26.09	HCA2	10	0	0	0	9.000000e-02	
-12	H1A	SLES	1	30.828	31.408	26.147	HCA2	10	0	0	0	9.000000e-02	
-13	O1	SLES	1	29.087	30.49	26.279	OC30A	10	14	0	0	-3.400000e-01	
-14	C2	SLES	1	28.503	29.727	27.319	CC32A	13	15	16	17	-1.000000e-02	
-15	H2A	SLES	1	27.804	30.366	27.931	HCA2	14	0	0	0	9.000000e-02	
-16	H2B	SLES	1	29.281	29.306	27.998	HCA2	14	0	0	0	9.000000e-02	
-17	C1	SLES	1	27.786	28.897	26.193	CC32A	14	18	19	20	-1.000000e-02	
-18	H1B	SLES	1	26.806	29.197	26.587	HCA2	17	0	0	0	9.000000e-02	
-19	H1A	SLES	1	28.461	28.076	26.632	HCA2	17	0	0	0	9.000000e-02	
-20	O1	SLES	1	27.309	27.793	25.468	OC30A	17	21	0	0	-3.400000e-01	
-21	C1	SLES	1	26.479	26.857	26.141	CTL2	20	22	23	24	-1.800000e-01	
-22	H11	SLES	1	25.639	27.291	26.752	HAL2	21	0	0	0	9.000000e-02	
-23	H12	SLES	1	27.089	26.219	26.829	HAL2	21	0	0	0	9.000000e-02	
-24	C2	SLES	1	25.959	26.079	24.933	CTL2	21	25	26	27	-1.800000e-01	
-25	H21	SLES	1	25.299	26.683	24.265	HAL2	24	0	0	0	9.000000e-02	
-26	H22	SLES	1	26.775	25.623	24.321	HAL2	24	0	0	0	9.000000e-02	
-27	C3	SLES	1	25.166	25	25.552	CTL2	24	28	29	30	-1.800000e-01	
-28	H31	SLES	1	24.374	25.53	26.148	HAL2	27	0	0	0	9.000000e-02	
-29	H32	SLES	1	25.893	24.446	26.208	HAL2	27	0	0	0	9.000000e-02	
-30	C4	SLES	1	24.47	23.973	24.719	CTL2	27	31	32	33	-1.800000e-01	
-31	H41	SLES	1	23.721	24.443	24.035	HAL2	30	0	0	0	9.000000e-02	
-32	H42	SLES	1	25.193	23.397	24.095	HAL2	30	0	0	0	9.000000e-02	
-33	C5	SLES	1	23.845	23.159	25.86	CTL2	30	34	35	36	-1.800000e-01	
-34	H51	SLES	1	23.187	23.811	26.494	HAL2	33	0	0	0	9.000000e-02	
-35	H52	SLES	1	24.641	22.777	26.552	HAL2	33	0	0	0	9.000000e-02	
-36	C6	SLES	1	23.033	21.996	25.484	CTL2	33	37	38	39	-1.800000e-01	
-37	H61	SLES	1	22.025	22.151	25.956	HAL2	36	0	0	0	9.000000e-02	
-38	H62	SLES	1	23.483	21.114	26.014	HAL2	36	0	0	0	9.000000e-02	
-39	C7	SLES	1	22.888	21.707	23.985	CTL2	36	40	41	42	-1.800000e-01	
-40	H71	SLES	1	22.373	22.516	23.415	HAL2	39	0	0	0	9.000000e-02	
-41	H72	SLES	1	23.849	21.466	23.474	HAL2	39	0	0	0	9.000000e-02	
-42	C8	SLES	1	22.025	20.5	24.062	CTL2	39	43	44	45	-1.800000e-01	
-43	H81	SLES	1	21.09	20.813	24.606	HAL2	42	0	0	0	9.000000e-02	
-44	H82	SLES	1	22.598	19.741	24.667	HAL2	42	0	0	0	9.000000e-02	
-45	C9	SLES	1	21.583	19.808	22.82	CTL2	42	46	47	48	-1.800000e-01	
-46	H91	SLES	1	20.987	20.501	22.185	HAL2	45	0	0	0	9.000000e-02	
-47	H92	SLES	1	22.466	19.449	22.245	HAL2	45	0	0	0	9.000000e-02	
-48	C10	SLES	1	20.753	18.675	23.42	CTL2	45	49	50	51	-1.800000e-01	
-49	H10	SLES	1	19.924	19.1	24.048	HAL2	48	0	0	0	9.000000e-02	
-50	H10	SLES	1	21.392	18.056	24.107	HAL2	48	0	0	0	9.000000e-02	
-51	C11	SLES	1	20.134	17.748	22.425	CTL2	48	52	53	54	-1.800000e-01	
-52	H11	SLES	1	19.484	18.362	21.759	HAL2	51	0	0	0	9.000000e-02	
-53	H11	SLES	1	20.961	17.312	21.818	HAL2	51	0	0	0	9.000000e-02	
-54	C12	SLES	1	19.337	16.67	23.165	CTL3	51	55	56	57	-2.700000e-01	
-55	H12	SLES	1	18.268	16.727	22.882	HAL3	54	0	0	0	9.000000e-02	
-56	H12	SLES	1	19.755	15.669	22.942	HAL3	54	0	0	0	9.000000e-02	
-57	H12	SLES	1	19.381	16.794	24.275	HAL3	54	0	0	0	9.000000e-02	
+1	NA	SLES	1	32.397	35.231	26.737	NA	0	0	0	0	1	
+2	S	SLES	1	31.282	33.88	29.208	SL	3	4	5	6	1.33	
+3	OS1	SLES	1	30.788	33.072	28.08	OSL	2	7	0	0	-0.28	
+4	OS2	SLES	1	30.674	35.071	28.658	O2L	2	0	0	0	-0.65	
+5	OS3	SLES	1	32.652	33.652	28.81	O2L	2	0	0	0	-0.65	
+6	OS4	SLES	1	30.761	33.284	30.406	O2L	2	0	0	0	-0.65	
+7	C2	SLES	1	30.018	31.938	28.128	CC32A	3	8	9	10	-0.11	
+8	H2A	SLES	1	29.033	32.147	28.623	HCA2	7	0	0	0	0.09	
+9	H2B	SLES	1	30.55	31.115	28.675	HCA2	7	0	0	0	0.09	
+10	C1	SLES	1	29.84	31.605	26.631	CC32A	7	11	12	13	-0.01	
+11	H1B	SLES	1	29.337	32.448	26.09	HCA2	10	0	0	0	0.09	
+12	H1A	SLES	1	30.828	31.408	26.147	HCA2	10	0	0	0	0.09	
+13	O1	SLES	1	29.087	30.49	26.279	OC30A	10	14	0	0	-0.34	
+14	C2	SLES	1	28.503	29.727	27.319	CC32A	13	15	16	17	-0.01	
+15	H2A	SLES	1	27.804	30.366	27.931	HCA2	14	0	0	0	0.09	
+16	H2B	SLES	1	29.281	29.306	27.998	HCA2	14	0	0	0	0.09	
+17	C1	SLES	1	27.786	28.897	26.193	CC32A	14	18	19	20	-0.01	
+18	H1B	SLES	1	26.806	29.197	26.587	HCA2	17	0	0	0	0.09	
+19	H1A	SLES	1	28.461	28.076	26.632	HCA2	17	0	0	0	0.09	
+20	O1	SLES	1	27.309	27.793	25.468	OC30A	17	21	0	0	-0.34	
+21	C1	SLES	1	26.479	26.857	26.141	CTL2	20	22	23	24	-0.18	
+22	H11	SLES	1	25.639	27.291	26.752	HAL2	21	0	0	0	0.09	
+23	H12	SLES	1	27.089	26.219	26.829	HAL2	21	0	0	0	0.09	
+24	C2	SLES	1	25.959	26.079	24.933	CTL2	21	25	26	27	-0.18	
+25	H21	SLES	1	25.299	26.683	24.265	HAL2	24	0	0	0	0.09	
+26	H22	SLES	1	26.775	25.623	24.321	HAL2	24	0	0	0	0.09	
+27	C3	SLES	1	25.166	25	25.552	CTL2	24	28	29	30	-0.18	
+28	H31	SLES	1	24.374	25.53	26.148	HAL2	27	0	0	0	0.09	
+29	H32	SLES	1	25.893	24.446	26.208	HAL2	27	0	0	0	0.09	
+30	C4	SLES	1	24.47	23.973	24.719	CTL2	27	31	32	33	-0.18	
+31	H41	SLES	1	23.721	24.443	24.035	HAL2	30	0	0	0	0.09	
+32	H42	SLES	1	25.193	23.397	24.095	HAL2	30	0	0	0	0.09	
+33	C5	SLES	1	23.845	23.159	25.86	CTL2	30	34	35	36	-0.18	
+34	H51	SLES	1	23.187	23.811	26.494	HAL2	33	0	0	0	0.09	
+35	H52	SLES	1	24.641	22.777	26.552	HAL2	33	0	0	0	0.09	
+36	C6	SLES	1	23.033	21.996	25.484	CTL2	33	37	38	39	-0.18	
+37	H61	SLES	1	22.025	22.151	25.956	HAL2	36	0	0	0	0.09	
+38	H62	SLES	1	23.483	21.114	26.014	HAL2	36	0	0	0	0.09	
+39	C7	SLES	1	22.888	21.707	23.985	CTL2	36	40	41	42	-0.18	
+40	H71	SLES	1	22.373	22.516	23.415	HAL2	39	0	0	0	0.09	
+41	H72	SLES	1	23.849	21.466	23.474	HAL2	39	0	0	0	0.09	
+42	C8	SLES	1	22.025	20.5	24.062	CTL2	39	43	44	45	-0.18	
+43	H81	SLES	1	21.09	20.813	24.606	HAL2	42	0	0	0	0.09	
+44	H82	SLES	1	22.598	19.741	24.667	HAL2	42	0	0	0	0.09	
+45	C9	SLES	1	21.583	19.808	22.82	CTL2	42	46	47	48	-0.18	
+46	H91	SLES	1	20.987	20.501	22.185	HAL2	45	0	0	0	0.09	
+47	H92	SLES	1	22.466	19.449	22.245	HAL2	45	0	0	0	0.09	
+48	C10	SLES	1	20.753	18.675	23.42	CTL2	45	49	50	51	-0.18	
+49	H10	SLES	1	19.924	19.1	24.048	HAL2	48	0	0	0	0.09	
+50	H10	SLES	1	21.392	18.056	24.107	HAL2	48	0	0	0	0.09	
+51	C11	SLES	1	20.134	17.748	22.425	CTL2	48	52	53	54	-0.18	
+52	H11	SLES	1	19.484	18.362	21.759	HAL2	51	0	0	0	0.09	
+53	H11	SLES	1	20.961	17.312	21.818	HAL2	51	0	0	0	0.09	
+54	C12	SLES	1	19.337	16.67	23.165	CTL3	51	55	56	57	-0.27	
+55	H12	SLES	1	18.268	16.727	22.882	HAL3	54	0	0	0	0.09	
+56	H12	SLES	1	19.755	15.669	22.942	HAL3	54	0	0	0	0.09	
+57	H12	SLES	1	19.381	16.794	24.275	HAL3	54	0	0	0	0.09	
Index: tests/regression/Molecules/Copy/pre/tensid.potentials
===================================================================
--- tests/regression/Molecules/Copy/pre/tensid.potentials	(revision ccb487ddab59ad8050ce40929874510f2d9454f0)
+++ tests/regression/Molecules/Copy/pre/tensid.potentials	(revision 2034f3c5f9db8e8024a0f4db0cd3d1231e98ac24)
@@ -10,6 +10,6 @@
 	particle:	particle_type=CC326A,	element_name=C,	sigma=4.02,	epsilon=0.056,	sigma14=3.8,	epsilon14=0.01,	mass=12.011,	free=3,	charge=0;
 	particle:	particle_type=CC33A,	element_name=C,	sigma=4.08,	epsilon=0.078,	sigma14=3.8,	epsilon14=0.01,	mass=12.011,	free=3,	charge=0;
-	particle:	particle_type=NE,	element_name=NE,	sigma=3.06,	epsilon=0.086,	sigma14=3.06,	epsilon14=0.086,	mass=20.1797,	free=3,	charge=0;
-	particle:	particle_type=CLA,	element_name=CL,	sigma=4.54,	epsilon=0.15,	sigma14=4.54,	epsilon14=0.15,	mass=35.45,	free=3,	charge=0;
+	particle:	particle_type=NE,	element_name=Ne,	sigma=3.06,	epsilon=0.086,	sigma14=3.06,	epsilon14=0.086,	mass=20.1797,	free=3,	charge=0;
+	particle:	particle_type=CLA,	element_name=Cl,	sigma=4.54,	epsilon=0.15,	sigma14=4.54,	epsilon14=0.15,	mass=35.45,	free=3,	charge=0;
 	particle:	particle_type=DUM,	element_name=H,	sigma=0,	epsilon=0,	sigma14=0,	epsilon14=0,	mass=0,	free=3,	charge=0;
 	particle:	particle_type=NA,	element_name=Na,	sigma=2.7275,	epsilon=0.0469,	sigma14=2.7275,	epsilon14=0.0469,	mass=22.98977,	free=3,	charge=0;
@@ -24,5 +24,5 @@
 	particle:	particle_type=HAL1,	element_name=H,	sigma=2.64,	epsilon=0.022,	sigma14=2.64,	epsilon14=0.022,	mass=1.008,	free=3,	charge=0;
 	particle:	particle_type=HEL2,	element_name=H,	sigma=2.52,	epsilon=0.026,	sigma14=2.52,	epsilon14=0.026,	mass=1.008,	free=3,	charge=0;
-	particle:	particle_type=HE,	element_name=HE,	sigma=2.96,	epsilon=0.02127,	sigma14=2.96,	epsilon14=0.02127,	mass=4.0026,	free=3,	charge=0;
+	particle:	particle_type=HE,	element_name=He,	sigma=2.96,	epsilon=0.02127,	sigma14=2.96,	epsilon14=0.02127,	mass=4.0026,	free=3,	charge=0;
 	particle:	particle_type=HCA3,	element_name=H,	sigma=2.68,	epsilon=0.024,	sigma14=2.68,	epsilon14=0.024,	mass=1.008,	free=3,	charge=0;
 	particle:	particle_type=OHL,	element_name=O,	sigma=3.54,	epsilon=0.1521,	sigma14=3.54,	epsilon14=0.1521,	mass=15.9994,	free=3,	charge=0;
@@ -35,5 +35,5 @@
 	particle:	particle_type=HAL2,	element_name=H,	sigma=2.68,	epsilon=0.028,	sigma14=2.68,	epsilon14=0.028,	mass=1.008,	free=3,	charge=0;
 	particle:	particle_type=OCL,	element_name=O,	sigma=3.4,	epsilon=0.12,	sigma14=3.4,	epsilon14=0.12,	mass=15.9994,	free=3,	charge=0;
-	particle:	particle_type=MG,	element_name=MG,	sigma=2.37,	epsilon=0.015,	sigma14=2.37,	epsilon14=0.015,	mass=24.305,	free=3,	charge=0;
+	particle:	particle_type=MG,	element_name=Mg,	sigma=2.37,	epsilon=0.015,	sigma14=2.37,	epsilon14=0.015,	mass=24.305,	free=3,	charge=0;
 	particle:	particle_type=OC30A,	element_name=O,	sigma=3.3,	epsilon=0.1,	sigma14=3.3,	epsilon14=0.1,	mass=15.9994,	free=3,	charge=0;
 	particle:	particle_type=HAL3,	element_name=H,	sigma=2.68,	epsilon=0.024,	sigma14=2.68,	epsilon14=0.024,	mass=1.008,	free=3,	charge=0;