Index: tests/regression/Selection/Atoms/PushAtomSelection/post/empty.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/empty.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/empty.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,2 @@
+0
+	Created by molecuilder for unselect-atom-by-id test
Index: tests/regression/Selection/Atoms/PushAtomSelection/post/id01_missing.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/id01_missing.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/id01_missing.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,8 @@
+6
+	Created by molecuilder for select-atom-by-id
+H	0	1	0
+H	0	1	1
+H	1	0	0
+H	1	0	1
+H	1	1	0
+H	1	1	1
Index: tests/regression/Selection/Atoms/PushAtomSelection/post/id01_present.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/id01_present.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/id01_present.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,4 @@
+2
+	Created by molecuilder for unselect-atom-by-id
+H	0	0	0
+H	0	0	1
Index: tests/regression/Selection/Atoms/PushAtomSelection/post/id0_missing.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/id0_missing.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/id0_missing.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,9 @@
+7
+	Created by molecuilder for select-atom-by-id
+H	0	0	1
+H	0	1	0
+H	0	1	1
+H	1	0	0
+H	1	0	1
+H	1	1	0
+H	1	1	1
Index: tests/regression/Selection/Atoms/PushAtomSelection/post/id0_present.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/id0_present.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/id0_present.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,3 @@
+1
+	Created by molecuilder for unselect-atom-by-id
+H	0	0	0
Index: tests/regression/Selection/Atoms/PushAtomSelection/post/id1_missing.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/id1_missing.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/id1_missing.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,9 @@
+7
+	Created by molecuilder for select-atom-by-id
+H	0	0	0
+H	0	1	0
+H	0	1	1
+H	1	0	0
+H	1	0	1
+H	1	1	0
+H	1	1	1
Index: tests/regression/Selection/Atoms/PushAtomSelection/post/id1_present.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/id1_present.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/id1_present.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,3 @@
+1
+	Created by molecuilder for unselect-atom-by-id
+H	0	0	1
Index: tests/regression/Selection/Atoms/PushAtomSelection/post/id2_missing.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/id2_missing.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/id2_missing.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,9 @@
+7
+	Created by molecuilder for select-atom-by-id
+H	0	0	0
+H	0	0	1
+H	0	1	1
+H	1	0	0
+H	1	0	1
+H	1	1	0
+H	1	1	1
Index: tests/regression/Selection/Atoms/PushAtomSelection/post/id2_present.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/id2_present.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/id2_present.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,3 @@
+1
+	Created by molecuilder for unselect-atom-by-id
+H	0	1	0
Index: tests/regression/Selection/Atoms/PushAtomSelection/post/id3_missing.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/id3_missing.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/id3_missing.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,9 @@
+7
+	Created by molecuilder for select-atom-by-id
+H	0	0	0
+H	0	0	1
+H	0	1	0
+H	1	0	0
+H	1	0	1
+H	1	1	0
+H	1	1	1
Index: tests/regression/Selection/Atoms/PushAtomSelection/post/id3_present.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/id3_present.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/id3_present.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,3 @@
+1
+	Created by molecuilder for unselect-atom-by-id
+H	0	1	1
Index: tests/regression/Selection/Atoms/PushAtomSelection/post/id4_missing.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/id4_missing.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/id4_missing.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,9 @@
+7
+	Created by molecuilder for select-atom-by-id
+H	0	0	0
+H	0	0	1
+H	0	1	0
+H	0	1	1
+H	1	0	1
+H	1	1	0
+H	1	1	1
Index: tests/regression/Selection/Atoms/PushAtomSelection/post/id4_present.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/id4_present.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/id4_present.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,3 @@
+1
+	Created by molecuilder for unselect-atom-by-id
+H	1	0	0
Index: tests/regression/Selection/Atoms/PushAtomSelection/post/id5_missing.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/id5_missing.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/id5_missing.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,9 @@
+7
+	Created by molecuilder for select-atom-by-id
+H	0	0	0
+H	0	0	1
+H	0	1	0
+H	0	1	1
+H	1	0	0
+H	1	1	0
+H	1	1	1
Index: tests/regression/Selection/Atoms/PushAtomSelection/post/id5_present.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/id5_present.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/id5_present.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,3 @@
+1
+	Created by molecuilder for unselect-atom-by-id
+H	1	0	1
Index: tests/regression/Selection/Atoms/PushAtomSelection/post/id6_missing.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/id6_missing.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/id6_missing.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,9 @@
+7
+	Created by molecuilder for select-atom-by-id
+H	0	0	0
+H	0	0	1
+H	0	1	0
+H	0	1	1
+H	1	0	0
+H	1	0	1
+H	1	1	1
Index: tests/regression/Selection/Atoms/PushAtomSelection/post/id6_present.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/id6_present.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/id6_present.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,3 @@
+1
+	Created by molecuilder for unselect-atom-by-id
+H	1	1	0
Index: tests/regression/Selection/Atoms/PushAtomSelection/post/id7_missing.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/id7_missing.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/id7_missing.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,9 @@
+7
+	Created by molecuilder for select-atom-by-id
+H	0	0	0
+H	0	0	1
+H	0	1	0
+H	0	1	1
+H	1	0	0
+H	1	0	1
+H	1	1	0
Index: tests/regression/Selection/Atoms/PushAtomSelection/post/id7_present.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/id7_present.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/id7_present.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,3 @@
+1
+	Created by molecuilder for unselect-atom-by-id
+H	1	1	1
Index: tests/regression/Selection/Atoms/PushAtomSelection/post/test-undo.xyz
===================================================================
--- tests/regression/Selection/Atoms/PushAtomSelection/post/test-undo.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
+++ tests/regression/Selection/Atoms/PushAtomSelection/post/test-undo.xyz	(revision 3213f29e16ba9cf8c7dc57a7343907df2ec3988a)
@@ -0,0 +1,10 @@
+8
+	Created by molecuilder for select-atom-by-id
+H	0	0	0
+H	0	0	1
+H	0	1	0
+H	0	1	1
+H	1	0	0
+H	1	0	1
+H	1	1	0
+H	1	1	1