Index: src/Bond/AdjacencyMatcher/Makefile.am
===================================================================
--- src/Bond/AdjacencyMatcher/Makefile.am	(revision 8e790ebd981dac78daa03f5e06560ba8ea84a21a)
+++ src/Bond/AdjacencyMatcher/Makefile.am	(revision 3532b77102b83baecdd39fade5a59f5aaf230ed0)
@@ -8,4 +8,5 @@
 BUILT_SOURCES =
 bin_PROGRAMS =
+check_PROGRAMS =
 EXTRA_DIST =
 
@@ -15,5 +16,5 @@
 	${CodePatterns_CFLAGS}
 
-bin_PROGRAMS += \
+check_PROGRAMS += \
 	adjacencymatcher
 
Index: src/Tesselation/TriangleMatcher/Makefile.am
===================================================================
--- src/Tesselation/TriangleMatcher/Makefile.am	(revision 8e790ebd981dac78daa03f5e06560ba8ea84a21a)
+++ src/Tesselation/TriangleMatcher/Makefile.am	(revision 3532b77102b83baecdd39fade5a59f5aaf230ed0)
@@ -8,4 +8,5 @@
 BUILT_SOURCES =
 bin_PROGRAMS =
+check_PROGRAMS =
 EXTRA_DIST =
 
@@ -15,5 +16,5 @@
 	${CodePatterns_CFLAGS}
 
-bin_PROGRAMS += \
+check_PROGRAMS += \
 	trianglematcher
 
Index: tests/GuiChecks/Makefile.am
===================================================================
--- tests/GuiChecks/Makefile.am	(revision 8e790ebd981dac78daa03f5e06560ba8ea84a21a)
+++ tests/GuiChecks/Makefile.am	(revision 3532b77102b83baecdd39fade5a59f5aaf230ed0)
@@ -217,5 +217,5 @@
 max_jobs = 4
  
-guicheck: atlocal package.m4 $(TESTSUITE)
+guicheck: adjacencymatcher atlocal package.m4 molecuilder molecuilderguitest trianglematcher $(TESTSUITE)
 	nrjobs=; \
 	for flag in $$MAKEFLAGS; do \
@@ -227,5 +227,5 @@
 	$(SHELL) '$(TESTSUITE)' $$nrjobs AUTOTEST_PATH='$(abs_top_builddir)/src' $(TESTSUITEFLAGS)
 
-installguicheck: atconfig atlocal $(TESTSUITE)
+installguicheck: adjacencymatcher atconfig atlocal molecuilder molecuilderguitest trianglematcher $(TESTSUITE)
 	nrjobs=; \
 	for flag in $$MAKEFLAGS; do \
@@ -242,5 +242,5 @@
 
 AUTOTEST = $(AUTOM4TE) --language=autotest
-$(TESTSUITE): $(srcdir)/testsuite.at molecuilder molecuilderguitest package.m4 trianglematcher $(TESTSCRIPTS)
+$(TESTSUITE): $(srcdir)/testsuite.at package.m4 $(TESTSCRIPTS)
 	$(AUTOTEST) -I '$(srcdir)' -o $@.tmp $@.at
 	mv $@.tmp $@
Index: tests/GuiChecks/adjacencymatcher.in
===================================================================
--- tests/GuiChecks/adjacencymatcher.in	(revision 8e790ebd981dac78daa03f5e06560ba8ea84a21a)
+++ tests/GuiChecks/adjacencymatcher.in	(revision 3532b77102b83baecdd39fade5a59f5aaf230ed0)
@@ -20,8 +20,8 @@
 --track-origins=yes \
 --show-reachable=yes \
-"${AUTOTEST_PATH}/Bond/AdjacencyMatcher/adjacencymatcher" \
+"${topdir}/src/Bond/AdjacencyMatcher/adjacencymatcher" \
 ${1+"$@"}
 else
-"${AUTOTEST_PATH}/Bond/AdjacencyMatcher/adjacencymatcher" \
+"${topdir}/src/Bond/AdjacencyMatcher/adjacencymatcher" \
 ${1+"$@"}
 fi
Index: tests/GuiChecks/trianglematcher.in
===================================================================
--- tests/GuiChecks/trianglematcher.in	(revision 8e790ebd981dac78daa03f5e06560ba8ea84a21a)
+++ tests/GuiChecks/trianglematcher.in	(revision 3532b77102b83baecdd39fade5a59f5aaf230ed0)
@@ -20,8 +20,8 @@
 --track-origins=yes \
 --show-reachable=yes \
-"${AUTOTEST_PATH}/Tesselation/TriangleMatcher/trianglematcher" \
+"${topdir}/src/Tesselation/TriangleMatcher/trianglematcher" \
 ${1+"$@"}
 else
-"${AUTOTEST_PATH}/Tesselation/TriangleMatcher/trianglematcher" \
+"${topdir}/src/Tesselation/TriangleMatcher/trianglematcher" \
 ${1+"$@"}
 fi
Index: tests/Tesselations/Makefile.am
===================================================================
--- tests/Tesselations/Makefile.am	(revision 8e790ebd981dac78daa03f5e06560ba8ea84a21a)
+++ tests/Tesselations/Makefile.am	(revision 3532b77102b83baecdd39fade5a59f5aaf230ed0)
@@ -78,5 +78,5 @@
 max_jobs = 4
  
-check-local: atconfig atlocal $(TESTSUITE)
+check-local: atconfig atlocal molecuilder trianglematcher $(TESTSUITE)
 	nrjobs=; \
 	for flag in $$MAKEFLAGS; do \
@@ -88,5 +88,5 @@
 	$(SHELL) '$(TESTSUITE)' $$nrjobs AUTOTEST_PATH='$(abs_top_builddir)/src' $(TESTSUITEFLAGS)
 
-installcheck-local: atconfig atlocal $(TESTSUITE)
+installcheck-local: atconfig atlocal molecuilder trianglematcher $(TESTSUITE)
 	nrjobs=; \
 	for flag in $$MAKEFLAGS; do \
@@ -103,5 +103,5 @@
 
 AUTOTEST = $(AUTOM4TE) --language=autotest
-$(TESTSUITE): $(srcdir)/testsuite.at molecuilder package.m4 trianglematcher $(TESTSCRIPTS)
+$(TESTSUITE): $(srcdir)/testsuite.at package.m4 $(TESTSCRIPTS)
 	$(AUTOTEST) -I '$(srcdir)' -o $@.tmp $@.at
 	mv $@.tmp $@
Index: tests/Tesselations/trianglematcher.in
===================================================================
--- tests/Tesselations/trianglematcher.in	(revision 8e790ebd981dac78daa03f5e06560ba8ea84a21a)
+++ tests/Tesselations/trianglematcher.in	(revision 3532b77102b83baecdd39fade5a59f5aaf230ed0)
@@ -20,8 +20,8 @@
 --track-origins=yes \
 --show-reachable=yes \
-"${AUTOTEST_PATH}/Tesselation/TriangleMatcher/trianglematcher" \
+"${topdir}/src/Tesselation/TriangleMatcher/trianglematcher" \
 ${1+"$@"}
 else
-"${AUTOTEST_PATH}/Tesselation/TriangleMatcher/trianglematcher" \
+"${topdir}/src/Tesselation/TriangleMatcher/trianglematcher" \
 ${1+"$@"}
 fi
Index: tests/regression/Makefile.am
===================================================================
--- tests/regression/Makefile.am	(revision 8e790ebd981dac78daa03f5e06560ba8ea84a21a)
+++ tests/regression/Makefile.am	(revision 3532b77102b83baecdd39fade5a59f5aaf230ed0)
@@ -241,5 +241,5 @@
 max_jobs = 4
  
-check-local: atconfig atlocal $(TESTSUITE)
+check-local: adjacencymatcher atconfig atlocal molecuilder runpython trianglematcher $(TESTSUITE)
 	nrjobs=; \
 	for flag in $$MAKEFLAGS; do \
@@ -251,5 +251,5 @@
 	$(SHELL) '$(TESTSUITE)' $$nrjobs AUTOTEST_PATH='$(abs_top_builddir)/src' $(TESTSUITEFLAGS)
 
-installcheck-local: atconfig atlocal $(TESTSUITE)
+installcheck-local: adjacencymatcher atconfig atlocal molecuilder runpython trianglematcher $(TESTSUITE)
 	nrjobs=; \
 	for flag in $$MAKEFLAGS; do \
@@ -266,5 +266,5 @@
 
 AUTOTEST = $(AUTOM4TE) --language=autotest
-$(TESTSUITE): $(srcdir)/testsuite.at molecuilder package.m4 runpython trianglematcher $(TESTSCRIPTS)
+$(TESTSUITE): $(srcdir)/testsuite.at package.m4 $(TESTSCRIPTS)
 	$(AUTOTEST) -I '$(srcdir)' -o $@.tmp $@.at
 	mv $@.tmp $@
Index: tests/regression/adjacencymatcher.in
===================================================================
--- tests/regression/adjacencymatcher.in	(revision 8e790ebd981dac78daa03f5e06560ba8ea84a21a)
+++ tests/regression/adjacencymatcher.in	(revision 3532b77102b83baecdd39fade5a59f5aaf230ed0)
@@ -20,8 +20,8 @@
 --track-origins=yes \
 --show-reachable=yes \
-"${AUTOTEST_PATH}/Bond/AdjacencyMatcher/adjacencymatcher" \
+"${topdir}/src/Bond/AdjacencyMatcher/adjacencymatcher" \
 ${1+"$@"}
 else
-"${AUTOTEST_PATH}/Bond/AdjacencyMatcher/adjacencymatcher" \
+"${topdir}/src/Bond/AdjacencyMatcher/adjacencymatcher" \
 ${1+"$@"}
 fi
Index: tests/regression/trianglematcher.in
===================================================================
--- tests/regression/trianglematcher.in	(revision 8e790ebd981dac78daa03f5e06560ba8ea84a21a)
+++ tests/regression/trianglematcher.in	(revision 3532b77102b83baecdd39fade5a59f5aaf230ed0)
@@ -20,8 +20,8 @@
 --track-origins=yes \
 --show-reachable=yes \
-"${AUTOTEST_PATH}/Tesselation/TriangleMatcher/trianglematcher" \
+"${topdir}/src/Tesselation/TriangleMatcher/trianglematcher" \
 ${1+"$@"}
 else
-"${AUTOTEST_PATH}/Tesselation/TriangleMatcher/trianglematcher" \
+"${topdir}/src/Tesselation/TriangleMatcher/trianglematcher" \
 ${1+"$@"}
 fi