Index: tests/Fragmentations/defs.in
===================================================================
--- tests/Fragmentations/defs.in	(revision d4a44c33452f58b4160eb88383f4287dfc249470)
+++ tests/Fragmentations/defs.in	(revision 3738f09a1261e51cc253cbaa8f4766bb8f945d68)
@@ -57,7 +57,7 @@
 	echo "Current dir is `pwd`, calling $MOLECUILDER $mol.conf --select-molecule-by-id 0 -f $FILENAME --order $ORDER --distance $DISTANCE."
 	if [ -e $mol.dbond ]; then
-		$MOLECUILDER -i ../$mol.xyz -A $mol.dbond --select-molecule-by-id 0 -f $FILENAME --order $ORDER --distance $DISTANCE &>stdout || exitcode=$?
+		$MOLECUILDER -i ../$mol.xyz -A $mol.dbond --select-all-atoms --create-adjacency --select-molecule-by-id 0 -f $FILENAME --order $ORDER --distance $DISTANCE &>stdout || exitcode=$?
 	else
-		$MOLECUILDER -i ../$mol.xyz --select-molecule-by-id 0 -f $FILENAME --order $ORDER --distance $DISTANCE $>stdout || exitcode=$?
+		$MOLECUILDER -i ../$mol.xyz --select-all-atoms --create-adjacency --select-molecule-by-id 0 -f $FILENAME --order $ORDER --distance $DISTANCE $>stdout || exitcode=$?
 	fi
 	cat <stdout
Index: tests/regression/Fragmentation/FragmentMolecule/testsuite-fragmentation-fragment-molecule.at
===================================================================
--- tests/regression/Fragmentation/FragmentMolecule/testsuite-fragmentation-fragment-molecule.at	(revision d4a44c33452f58b4160eb88383f4287dfc249470)
+++ tests/regression/Fragmentation/FragmentMolecule/testsuite-fragmentation-fragment-molecule.at	(revision 3738f09a1261e51cc253cbaa8f4766bb8f945d68)
@@ -3,5 +3,5 @@
 AT_SETUP([Fragmentation - Fragmentation])
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Fragmentation/FragmentMolecule/pre/test.conf .], 0)
-AT_CHECK([../../molecuilder -i test.conf  -v 1 --select-molecule-by-id 0 -f ./BondFragment --distance 1.55 --order 2], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i test.conf  -v 1 --select-all-atoms --create-adjacency --select-molecule-by-id 0 -f ./BondFragment --distance 1.55 --order 2], 0, [ignore], [ignore])
 AT_CHECK([ls -l BondFragment*.conf | wc -l], 0, [5
 ], [ignore])
Index: tests/regression/Graph/DepthFirstSearch/testsuite-graph-depth-first-search.at
===================================================================
--- tests/regression/Graph/DepthFirstSearch/testsuite-graph-depth-first-search.at	(revision d4a44c33452f58b4160eb88383f4287dfc249470)
+++ tests/regression/Graph/DepthFirstSearch/testsuite-graph-depth-first-search.at	(revision 3738f09a1261e51cc253cbaa8f4766bb8f945d68)
@@ -4,5 +4,5 @@
 AT_KEYWORDS([graph])
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Graph/DepthFirstSearch/pre/test.conf .], 0)
-AT_CHECK([../../molecuilder -i test.conf  -v 3 -D 2.], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder -i test.conf -v 3 --select-all-atoms --create-adjacency -D 2.], 0, [stdout], [stderr])
 AT_CHECK([fgrep -c "No rings were detected in the molecular structure." stdout], 0, [1
 ], [ignore])
Index: tests/regression/Molecules/SaveAdjacency/testsuite-molecules-save-adjacency.at
===================================================================
--- tests/regression/Molecules/SaveAdjacency/testsuite-molecules-save-adjacency.at	(revision d4a44c33452f58b4160eb88383f4287dfc249470)
+++ tests/regression/Molecules/SaveAdjacency/testsuite-molecules-save-adjacency.at	(revision 3738f09a1261e51cc253cbaa8f4766bb8f945d68)
@@ -4,5 +4,5 @@
 AT_KEYWORDS([Molecules])
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/SaveAdjacency/pre/test.conf .], 0)
-AT_CHECK([../../molecuilder -i test.conf  -v 1 --select-molecule-by-id 0 -J test.adj], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder -i test.conf  -v 1 --select-all-atoms --create-adjacency --select-molecule-by-id 0 -J test.adj], 0, [stdout], [stderr])
 AT_CHECK([file=test.adj; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/SaveAdjacency/post/$file], 0, [ignore], [ignore])
 AT_CLEANUP
Index: tests/regression/Molecules/SaveBonds/testsuite-molecules-save-bonds.at
===================================================================
--- tests/regression/Molecules/SaveBonds/testsuite-molecules-save-bonds.at	(revision d4a44c33452f58b4160eb88383f4287dfc249470)
+++ tests/regression/Molecules/SaveBonds/testsuite-molecules-save-bonds.at	(revision 3738f09a1261e51cc253cbaa8f4766bb8f945d68)
@@ -4,5 +4,5 @@
 AT_KEYWORDS([Molecules])
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/SaveBonds/pre/test.conf .], 0)
-AT_CHECK([../../molecuilder -i test.conf  -v 1 --select-molecule-by-id 0 -j test.dbond], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder -i test.conf  -v 1 --select-all-atoms --create-adjacency --select-molecule-by-id 0 -j test.dbond], 0, [stdout], [stderr])
 AT_CHECK([file=test.dbond; diff $file ${abs_top_srcdir}/${AUTOTEST_PATH}/Molecules/SaveBonds/post/$file], 0, [ignore], [ignore])
 AT_CLEANUP