Index: src/unittests/Makefile.am
===================================================================
--- src/unittests/Makefile.am	(revision 78b59342efdef84002909010c97948f27e3de0dd)
+++ src/unittests/Makefile.am	(revision 4076fcc9b9d836715dfe1bba1c9247bfdd385a93)
@@ -27,5 +27,4 @@
   LinkedCellUnitTest \
   ListOfBondsUnitTest \
-  LogUnitTest \
   manipulateAtomsTest \
   MenuDescriptionUnitTest \
@@ -84,5 +83,5 @@
   LinkedCellUnitTest.cpp \
   listofbondsunittest.cpp \
-  logunittest.cpp \
+  ../Helpers/unittests/LogUnitTest.cpp \
   ../LinearAlgebra/unittests/MatrixContentSymmetricUnitTest.cpp \
   ../LinearAlgebra/unittests/MatrixContentUnitTest.cpp \
@@ -124,5 +123,5 @@
   LinkedCellUnitTest.hpp \
   listofbondsunittest.hpp \
-  logunittest.hpp \
+  ../Helpers/unittests/LogUnitTest.hpp \
   manipulateAtomsTest.hpp \
   ../LinearAlgebra/unittests/MatrixContentSymmetricUnitTest.hpp \
@@ -180,7 +179,4 @@
 ListOfBondsUnitTest_LDADD = ${ALLLIBS}
 
-LogUnitTest_SOURCES = UnitTestMain.cpp logunittest.cpp logunittest.hpp
-LogUnitTest_LDADD = ${ALLLIBS}
-
 manipulateAtomsTest_SOURCES = UnitTestMain.cpp manipulateAtomsTest.cpp manipulateAtomsTest.hpp
 manipulateAtomsTest_LDADD = ${UILIBS} ${ALLLIBS}
Index: src/unittests/logunittest.cpp
===================================================================
--- src/unittests/logunittest.cpp	(revision 78b59342efdef84002909010c97948f27e3de0dd)
+++ 	(revision )
@@ -1,67 +1,0 @@
-/*
- * Project: MoleCuilder
- * Description: creates and alters molecular systems
- * Copyright (C)  2010 University of Bonn. All rights reserved.
- * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
- */
-
-/*
- * logunittest.cpp
- */
-
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-using namespace std;
-
-#include <cppunit/CompilerOutputter.h>
-#include <cppunit/extensions/TestFactoryRegistry.h>
-#include <cppunit/ui/text/TestRunner.h>
-
-#include "logunittest.hpp"
-#include "Helpers/Log.hpp"
-#include "Helpers/defs.hpp"
-#include "Helpers/Verbose.hpp"
-
-#ifdef HAVE_TESTRUNNER
-#include "UnitTestMain.hpp"
-#endif /*HAVE_TESTRUNNER*/
-
-/********************************************** Test classes **************************************/
-
-// Registers the fixture into the 'registry'
-CPPUNIT_TEST_SUITE_REGISTRATION( LogTest );
-
-
-void LogTest::setUp()
-{
-};
-
-void LogTest::tearDown()
-{
-  logger::purgeInstance();
-  errorLogger::purgeInstance();
-};
-
-/**
- * UnitTest for log()
- */
-void LogTest::logTest()
-{
-  logger::getInstance().setVerbosity(2);
-  DoLog(0) && (Log() << Verbose(0) << "Verbosity level is set to 2." << endl);
-  DoLog(0) && (Log() << Verbose(0) << "Test level 0" << endl);
-  DoLog(1) && (Log() << Verbose(1) << "Test level 1" << endl);
-  DoLog(2) && (Log() << Verbose(2) << "Test level 2" << endl);
-  DoLog(3) && (Log() << Verbose(3) << "Test level 3" << endl);
-  DoLog(4) && (Log() << Verbose(4) << "Test level 4" << endl);
-
-  DoLog(0) && (Log() << Verbose(0) << "Output a log message." << endl);
-  DoeLog(0) && (eLog()<< Verbose(0) << "Output an error message." << endl);
-  setVerbosity(3);
-  DoLog(4) && (Log() << Verbose(4) << "This should not be printed." << endl);
-  DoeLog(4) && (eLog()<< Verbose(4) << "This should not be printed." << endl);
-};
Index: src/unittests/logunittest.hpp
===================================================================
--- src/unittests/logunittest.hpp	(revision 78b59342efdef84002909010c97948f27e3de0dd)
+++ 	(revision )
@@ -1,26 +1,0 @@
-/*
- * logunittest.hpp
- */
-
-#ifndef LOGTEST_HPP_
-#define LOGTEST_HPP_
-
-#include <cppunit/extensions/HelperMacros.h>
-
-
-/********************************************** Test classes **************************************/
-
-class LogTest : public CppUnit::TestFixture
-{
-    CPPUNIT_TEST_SUITE( LogTest) ;
-    CPPUNIT_TEST ( logTest );
-    CPPUNIT_TEST_SUITE_END();
-
-public:
-    void setUp();
-    void tearDown();
-
-    void logTest();
-};
-
-#endif /* LOGTEST_HPP_ */